// OpenSSL.h : Hauptheaderdatei fr die OpenSSL-DLL
//

#pragma once

#ifndef __AFXWIN_H__
	#error "'stdafx.h' vor dieser Datei fr PCH einschlieen"
#endif

#include "resource.h"		// Hauptsymbole

#include "WndPlugIn.h"    // Fenster fr die PlugIn-Verwaltung mit Nettalk
// OpenSSL-Bibliothek
#include <openssl/ssl.h>
#include <openssl/err.h>
#include <openssl/rand.h>
// Maps fr Datenverwaltung
#include <afxcoll.h>

// Log der Anwendung
#include "Log.h"

#define snprintf _snprintf
///////////////////////////////////////////////////////////
// API
//#########################################################
// Deklarationen
extern "C" 
int WINAPI SSLDllGetVersionString(char *version, int size);

struct cert_info {
	char subject[256];
	char *subject_word[12];
	char issuer[256];
	char *issuer_word[12];
	char algorithm[32];
	int algorithm_bits;
	char sign_algorithm[32];
	int sign_algorithm_bits;
	char notbefore[32];
	char notafter[32];

	int rsa_tmp_bits;
};

struct chiper_info {
	char version[16];
	char chiper[24];
	int chiper_bits;
};

class CSSLSocketData 
{
public:
	CSSLSocketData()
	{
		// Member initialisieren
		m_ssl = NULL;
		m_acceptInvalideCertificate = 0;
		m_serverFrameId = -1;
		memset(m_hostName, 0, sizeof(m_hostName));

		// Zeitstempel der Erzeugung
		GetSystemTime(&m_st);
	}

public:
	SSL *m_ssl;
	int m_acceptInvalideCertificate;
	int m_serverFrameId;
	char m_hostName[64];

protected:
	SYSTEMTIME m_st;
};

// COpenSSLApp
// Siehe OpenSSL.cpp fr die Implementierung dieser Klasse
//

class COpenSSLApp : public CWinApp, public CLog
{
public:
	COpenSSLApp();
	~COpenSSLApp();

public:
	 CMap<SOCKET, SOCKET, CSSLSocketData*, CSSLSocketData*> m_mapSSLSocketData; 
	                                 // Map zur Verwaltung der CSSLSocketData-Objekte
	                                 // Zum jeweiligen Socket die entsprechenden Verbindungsdaten
	                                 // in einem CSSLSocketData-Objekt halten.
	SSL_CTX *m_ctx;                  // Hauptkontext von SSL

	CSSLSocketData &SSLSocketDataRequest(SOCKET sock) 
	{
		CSSLSocketData *sd;
		if (m_mapSSLSocketData.Lookup(sock, sd)) {

			return *sd;
		} 

		// Neues Object erzeugen
		sd = new CSSLSocketData();
		m_mapSSLSocketData.SetAt(sock, sd);

		return *sd;
	}

public: // PlugIn
	CWndPlugIn *m_wndPlugIn;
	
// berschreibungen
public:
	virtual BOOL InitInstance();
	virtual int ExitInstance();

	DECLARE_MESSAGE_MAP()
};

extern COpenSSLApp theApp;
