// WndPlugIn.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "OpenSSL.h"
#include "WndPlugIn.h"

// CWndPlugIn

IMPLEMENT_DYNAMIC(CWndPlugIn, CWnd)

CWndPlugIn::CWndPlugIn() : CLog(LOG_CHANNEL_PLUGIN)
{
	// Member initialisieren
	m_hNTalkHwnd = NULL;
	m_strPluginName = "OpenSSL";
}

CWndPlugIn::~CWndPlugIn()
{
}


BEGIN_MESSAGE_MAP(CWndPlugIn, CWnd)
	ON_MESSAGE(WM_SETTEXT, OnSetText)
END_MESSAGE_MAP()

// CWndPlugIn-Meldungshandler

LRESULT CWndPlugIn::OnSetText(WPARAM wParam, LPARAM lParam)
{
	logBeginEnd("OnSetText[0x%08X][%s]", wParam, (char*)lParam);

	CString commandLine((char*)lParam), command, tmp;

	// Pruefe ob Befehl mit Parameter?
	if (commandLine.Find(" ", 0) == -1) {

		// Kommando uebernehmen
		command = commandLine;

		// Klein sicherstellen
		command.MakeLower();

		// Kommando auswerten
		if (command == "unload") {

			// Das PlugIn beendet sich durchs endladen der DLL
			/*
			// Bestaetigung zueruecksenden
			tmp.Format("%s unload", theApp.m_strPluginName);
			theApp.SendPlain(tmp);
			// Anwendung beenden
			PostQuitMessage(0);
			*/

			//AfxMessageBox("The PlugIn is an interface from OpenSSL.dll and cannot removed.");

		} else if (command == "show") {

			/*
			UpdateData(FALSE);
			// Fenster zur Konfiguration einblenden.
			ShowWindow(TRUE);
			*/
			ShowPlugIn();

		} else {

			logBeginEnd("OnSetText.unknown command[%s]", command);
		}
	} else {

		CString param;
		CStringArray params;
		// Kommando extrahieren
		int pos = commandLine.Find(" ", 0), posNext;
		command = commandLine.Left(pos);

		// Klein sicherstellen
		command.MakeLower();

		if (command == "return" || command == "returnerror") {

				commandLine += (TCHAR)0x1B;
		}

		// Parameter extrahieren (Trennzeichen ist 0x1B)
		pos++;
		while ((posNext = commandLine.Find((TCHAR)0x1B, pos)) != -1) {

			param = commandLine.Mid(pos, (posNext - pos));
			logBeginEnd("OnSetText.param%i[%s][len:%i]", params.GetSize() + 1, param, param.GetLength());
			params.Add(param);
			pos = posNext + 1;
		}

		return ExecuteCommand(command, params);
	}

	// Sicherheitshalber auch hier -1, da Nettalk ansonsten das plugin ausklinkt.
	return -1;
}

int CWndPlugIn::InstPlugIn(HWND hWnd)
{	
	// Bestehenden Handle Prfen
	if (m_hNTalkHwnd != 0 && ::IsWindow(m_hNTalkHwnd)) {

		logBeginEnd("InstPlugIn[ PlugIn already in use ]");
		return FALSE;
	}

	// Ermittelten Handle Prfen
	if (hWnd == 0 || !::IsWindow(hWnd)) {

		logBeginEnd("InstPlugIn[ Nettalk-WndHandle wrong ]");
		return FALSE;
	}

	// Fensterhandle halten
	m_hNTalkHwnd = hWnd;

	// ########################################################################
	CString str;
	// Plugin bei NetTalk anmelden. "<PluginName> inst <PluginHwnd> 1"
	str.Format("%s inst %u 1",  m_strPluginName, this->GetSafeHwnd());
	SendPlain(str);

	//#########################################################################
	// Jetzt sagen wir NetTalk, auf was fr Ereignisse das Plugin reagieren soll.

	//// "<PluginName> addevent <ScriptEvent>"
	//str.Format("%s addevent FrameChange", m_strPluginName);
	//SendPlain(str);

	//// "<PluginName> addevent <ScriptEvent>"
	//str.Format("%s addevent SendMsg", m_strPluginName);
	//SendPlain(str);

	//// "<PluginName> addevent <ScriptEvent>"
	//str.Format("%s addevent Chan_Msg", m_strPluginName);
	//SendPlain(str);

	//// "<PluginName> addevent <ScriptEvent>"
	//str.Format("%s addevent Serv_Query", m_strPluginName);
	//SendPlain(str);

	//// "<PluginName> addevent <ScriptEvent>"
	//str.Format("%s addevent SendNotice", m_strPluginName);
	//SendPlain(str);

	//// "<PluginName> addevent <ScriptEvent>"
	//str.Format("%s addevent Serv_Notice", m_strPluginName);
	//SendPlain(str);

	//// "<PluginName> addevent <ScriptEvent>"
	//str.Format("%s addevent Serv_Action", m_strPluginName);
	//SendPlain(str);

	// "<PluginName> addevent <ScriptEvent>"
	str.Format("%s addevent Serv_Connect", m_strPluginName);
	SendPlain(str);

	return TRUE;
}

void CWndPlugIn::UnloadPlugIn()
{
	if (::IsWindow(m_hNTalkHwnd)) {

		// Plugin rausnehmen
		CString tmp;
		// Bestaetigung zueruecksenden
		tmp.Format("%s unload", m_strPluginName);
		SendPlain(tmp);
	}
}

void CWndPlugIn::ShowPlugIn()
{
	CString str;
	char version[32];
	memset(version, 0, sizeof(version));

	SSLDllGetVersionString(version, sizeof(version));

	str.Format("Addon\r\n---------------\r\nName: %s\r\nVersion: %s\r\nDeveloped for: Create Nettalk\r\n\r\nHint: The PlugIn is an interface from OpenSSL.dll and cannot removed.", m_strPluginName, version);
	AfxMessageBox(str, MB_ICONINFORMATION);
}

LRESULT CWndPlugIn::SendPlain(CString text)
{
	logBeginEnd("SendPlain[%s](%s)", ::IsWindow(m_hNTalkHwnd) ? "valid" : "invalid", text);
	if (!::IsWindow(m_hNTalkHwnd)) return 0;
	// Text an Nettalk senden
	return ::SendMessage(m_hNTalkHwnd, WM_SETTEXT, (WPARAM)(-1), (LPARAM)(LPCTSTR)text);
}

LRESULT CWndPlugIn::SendText(int FrameId, CString text)
{
	CString str;
	str.Format("%s send %u,%s", m_strPluginName, FrameId, text);
	logBeginEnd("SendText[%s](%s)", ::IsWindow(m_hNTalkHwnd) ? "valid" : "invalid", str);
	if (!::IsWindow(m_hNTalkHwnd) || FrameId == -1) return 0;
	// Textnachricht als send Befehl an Nettalk senden
	return ::SendMessage(m_hNTalkHwnd, WM_SETTEXT, (WPARAM)(-1), (LPARAM)(LPCTSTR)str);
}

LRESULT CWndPlugIn::SendCommand(int FrameId, CString cmd, CString text)
{
	CString str;
	str.Format("%s sendcom %u %s %s", m_strPluginName, FrameId, cmd, text);
	logBeginEnd("SendCommand[%s](%s)", ::IsWindow(m_hNTalkHwnd) ? "valid" : "invalid", str);
	if (!::IsWindow(m_hNTalkHwnd) || FrameId == -1) return 0;
	// Befehlsnachricht als sendcom Befehl an Nettalk senden
	return ::SendMessage(m_hNTalkHwnd, WM_SETTEXT, (WPARAM)(-1), (LPARAM)(LPCTSTR)str);
}

LRESULT CWndPlugIn::SendRequest(CString cmd)
{
	CString str;
	str.Format("%s request %s", m_strPluginName, cmd);
	logBeginEnd("SendRequest[%s](%s)", ::IsWindow(m_hNTalkHwnd) ? "valid" : "invalid", str);
	if (!::IsWindow(m_hNTalkHwnd)) return 0;
	// Befehlsnachricht als sendcom Befehl an Nettalk senden
	return ::SendMessage(m_hNTalkHwnd, WM_SETTEXT, (WPARAM)(-1), (LPARAM)(LPCTSTR)str);
}

LRESULT CWndPlugIn::ExecuteCommand(CString &cmd, CStringArray &params)
{
	static CString cmdPrev;
	static CStringArray paramsPrev;
	CString m_strNickPapagei;

	CString str;
	if (cmd == "FrameChange") {
		// Sub FrameChange(OldFrameID, NewFrameID)

		str.Format("Chan_Msg(\"%s\", \"%s\", \"%s\", %s, %s)", params[0], params[1], params[2], params[3], params[4]);
		return SendPlain(str);

	} else if (cmd == "Serv_Connect") {
		// Sub Serv_Connect(ConnID)

		if (m_strNickPapagei.GetLength() && params[1] == m_strNickPapagei) {

			str.Format("'s Papagei:<$14> %s", params[0]);
			return SendCommand(atol((char*)(LPCTSTR)params[3]), "/me", str);
		}

		str.Format("Chan_Msg(\"%s\", \"%s\", \"%s\", %s, %s)", params[0], params[1], params[2], params[3], params[4]);
		return SendPlain(str);

	} else if (cmd == "chan_msg") {
		// Chan_Msg(Text, Nick, Channel, FrameID, ConnID)

		if (m_strNickPapagei.GetLength() && params[1] == m_strNickPapagei) {

			str.Format("'s Papagei:<$14> %s", params[0]);
			return SendCommand(atol((char*)(LPCTSTR)params[3]), "/me", str);
		}

		str.Format("Chan_Msg(\"%s\", \"%s\", \"%s\", %s, %s)", params[0], params[1], params[2], params[3], params[4]);
		return SendPlain(str);

	} else if (cmd == "sendmsg") {
		// SendMsg(Text, Channel, FrameID, ConnID)

		str.Format("SendMsg(\"%s\", \"%s\", %s, %s)", params[0], params[1], params[2], params[3]);
		//return SendPlain(atol((char*)(LPCTSTR)params[2]), str);
		return SendPlain(str);

	} else if (cmd == "serv_query") {
		// Serv_Querry(Text, Nick, FrameID, ConnID)

		if (m_strNickPapagei.GetLength() && params[1] == m_strNickPapagei) {

			str.Format("'s Papagei:<$14> %s", params[0]);
			return SendCommand(atol((char*)(LPCTSTR)params[2]), "/me", str);
		}

		str.Format("Serv_Query(\"%s\", \"%s\", %s, %s)", params[0], params[1], params[2], params[3]);
		return SendPlain(str);

	} else if (cmd == "serv_action") {
		// Serv_Action(Text, Nick, FrameID, ConnID)

		if (m_strNickPapagei.GetLength() && params[1] == m_strNickPapagei) {

			str.Format("'s Papagei:<$14> %s", params[0]);
			return SendCommand(atol((char*)(LPCTSTR)params[2]), "/me", str);
		}

		str.Format("Serv_Action(\"%s\", \"%s\", %s, %s)", params[0], params[1], params[2], params[3]);
		return SendPlain(str);

	} else if (cmd == "sendnotice") {
		// SendNotice(Text, Receiver, FrameID, ConnID)

		str.Format("SendNotice(%s, %s, %s, %s)", params[0], params[1], params[2], params[3]);
		return SendPlain(str);

	} else if (cmd == "serv_notice") {
		// Serv_Notice(Text, Nick, Receiver, ConnID)

		// FrameID zur ConnID ermitteln
		cmdPrev = cmd;
		paramsPrev.Copy(params);
		str.Format("GetNoticeFrame(%s)", params[3]);
		return SendRequest(str);

	} else if (cmd == "return") {

		if (cmdPrev == "serv_notice") {

			if (m_strNickPapagei.GetLength() && paramsPrev[1] == m_strNickPapagei) {

				str.Format("'s Papagei:<$14> %s", paramsPrev[0]);
				return SendCommand(atol((char*)(LPCTSTR)params[0]), "/me", str);
			}

			str.Format("Serv_Notice(%s, %s, %s, %s)", paramsPrev[0], paramsPrev[1], paramsPrev[2], paramsPrev[3]);
			return SendPlain(str);
		}


	} else if (cmd == "returnerror") {


	} else if (cmd == "setnickpapagei") {

		m_strNickPapagei = params[0];
	}


	return -1;//SendPlain(str);
}
